#!/bin/sh
##
## Slackware install script for KMSBII
## Written by Marco A. Frias B. <marcoantoniofrias@gmail.com> on 02 June 2007
## Last revision on 12 June 2007
##
## Based on the KMSBII for Slackware GNU\Linux installation script
##
## This script will help you to install KDE Menu Sidebar Image
## improvement designed specifically for Slackware GNU\Linux
## distribution.
##
## 2006 (c) Ivan Lezhnev, Jr. <lezhnev@gmail.com>
##
## set -n

VERSION="v.2.1.0"
DISTRO="Slackware GNU\Linux distribution"

INSTPATH="$KDEDIR/share/apps/kicker/pics"
SYSINSTPATH="$KDEDIR/share/apps/kicker/pics"
ROOTDIR="$KDEDIR/share/apps/kmsbii-slackware-2.1.0"
BACKUPDIR="$KDEDIR/share/apps/kmsbii-slackware-2.1.0/backup"
TMPDIR="$KDEDIR/share/apps/kmsbii-slackware-2.1.0/tmp"

UNINFOFILE="$KDEDIR/share/apps/kmsbii-slackware-2.1.0/uninfofile"

SYSVERSION=`cat /etc/slackware-version`

# // -----------------------------------------------
#
#               MAIN INSTALL SYSTEM
#
# ----------------------------------------------- //

echo "
      KMSBII System-Wide Installation Mode  ------------------------------------ /

"

if [[ $SYSVERSION == "Slackware 10.0.0" ]]; then
 INSTDIR="$ROOTDIR/10.0.0"
 VERSION="Slackware GNU\Linux 10.0.0"
elif [[ $SYSVERSION == "Slackware 10.1.0" ]]; then
 INSTDIR="$ROOTDIR/10.1.0"
 VERSION="Slackware GNU\Linux 10.1.0"
elif [[ $SYSVERSION == "Slackware 10.2.0" ]]; then
 INSTDIR="$ROOTDIR/10.2.0"
 VERSION="Slackware GNU\Linux 10.2.0"
elif [[ $SYSVERSION == "Slackware 11.0.0" ]]; then
 INSTDIR="$ROOTDIR/11.0.0"
 VERSION="Slackware GNU\Linux 11.0.0"
fi

echo "
      :: 1 :: ==---------------------------------------------------------------- /

              Identifying $DISTRO version

"
echo "        
              Your version is:
              $VERSION
"

echo "
      :: 2 :: ==---------------------------------------------------------------- /

              Preparing target directory

"

if [ ! -d $SYSINSTPATH ]; then
   echo "
              Creating target directory
              (\`$SYSINSTPATH')
   "
   mkdir -p $SYSINSTPATH
else
   echo "
              Target directroy
              (\`$SYSINSTPATH')
              exists.

              Fine.
              Lets move on.
   "
fi

if [ ! -d $ROOTDIR ]; then
   echo "
              Creating KMSBII home directory
              (\`$ROOTDIR')
   "
   mkdir -p $ROOTDIR
fi

if [ -f $SYSINSTPATH/kside.png ]; then
 if [ -d $BACKUPDIR ]; then
    echo "
              As you've chosen system-wide installation mode original KDE Menu
              Sidebar Image files ought to be backened up.

              It seems like you have previously installed KMSBII
              and have a backup directory already.

              Backup directory
              (\`$BACKUPDIR')
              exists.

              Copying files into it.
    "
    cp $SYSINSTPATH/kside* $BACKUPDIR
    rm $SYSINSTPATH/kside*
 else
    echo "
              As you've chosen system-wide installation mode original KDE Menu
              Sidebar Image files ought to be backened up, but backup directory
              doesn't exist.

              Creating backup directory now
              (\`$BACKUPDIR')
    "
    mkdir -p $BACKUPDIR
    echo "
              Done,
              copying files into it.
    "
    cp $SYSINSTPATH/kside* $BACKUPDIR
    rm $SYSINSTPATH/kside*
 fi
fi

echo "
      :: 3 :: ==---------------------------------------------------------------- /

              Installing KDE Menu Sidebar Image Improvement for
              $VERSION
"
echo "
              Copying files to installation directory
              (\`$SYSINSTPATH')"

cp $INSTDIR/kside* $SYSINSTPATH
echo "
              Restarting kicker for changes to take effect."

touch $UNINFOFILE
echo "system" > $UNINFOFILE
echo "
              Done.
"
echo "
      :: ALL DONE :: ==---------------------------------------------------------- /

         Installation of KMSBII for $VERSION is now complete.
         LMB click on your KMenu button to check if everything is OK.

         Type:

         $ $ROOTDIR/install.sh info

         to see more information about the project.

         $ $ROOTDIR/install.sh help

         to see a brief message on usage of this script.

         Thank you for giving this KDE improvement a try.
"
