#!/bin/sh
#
# KMSBII for Slackware GNU\Linux installation script
#
# This script will help you to install KDE Menu Sidebar Image
# improvement designed specifically for Slackware GNU\Linux 
# distribution.
#
# Run:
#
# $ ./install.sh help
#
# to see more information on usage.
#
# 2006 (c) Ivan Lezhnev, Jr. <lezhnev@gmail.com>
#
# set -n

VERSION="v.2.1.0"
DISTRO="Slackware GNU\Linux distribution"

INSTPATH="$HOME/.kde/share/apps/kicker/pics"
SYSINSTPATH="$KDEDIR/share/apps/kicker/pics"
ROOTDIR="$HOME/.kde/share/apps/kmsbii-slackware-2.1.0"
BACKUPDIR="$HOME/.kde/share/apps/kmsbii-slackware-2.1.0/backup"
TMPDIR="$HOME/.kde/share/apps/kmsbii-slackware-2.1.0/tmp"

UNINFOFILE="$HOME/.kde/share/apps/kmsbii-slackware-2.1.0/uninfofile"

SYSVERSION=`cat /etc/slackware-version`

# // -----------------------------------------------
#
#                    Functions
#
# ----------------------------------------------- //

# --------------- Single User -------------------- #

user() {
echo "
      KMSBII Single User Installation Mode  ------------------------------------ /

"

sleep 1

if [[ $SYSVERSION == "Slackware 10.0.0" ]]; then
 INSTDIR="./10.0.0"
 VERSION="Slackware GNU\Linux 10.0.0"
elif [[ $SYSVERSION == "Slackware 10.1.0" ]]; then
 INSTDIR="./10.1.0"
 VERSION="Slackware GNU\Linux 10.1.0"
elif [[ $SYSVERSION == "Slackware 10.2.0" ]]; then
 INSTDIR="./10.2.0"
 VERSION="Slackware GNU\Linux 10.2.0"
elif [[ $SYSVERSION == "Slackware 11.0.0" ]]; then
 INSTDIR="./11.0.0"
 VERSION="Slackware GNU\Linux 11.0.0"
fi

echo "
      :: 1 :: ==---------------------------------------------------------------- /

              Identifying $DISTRO version

"
sleep 3
echo "        
              Your version is:
              $VERSION
"
sleep 3
echo "
      :: 2 :: ==---------------------------------------------------------------- /

              Preparing target directory

"

sleep 5

if [ ! -d $INSTPATH ]; then
   echo "
              Creating target directory
              (\`$INSTPATH')
   "
   mkdir -p $INSTPATH
   sleep 5
else
   echo "
              Target directroy
              (\`$INSTPATH')
              exists.

              Fine.
              Lets move on.
   "
   sleep 5
fi

if [ ! -d $ROOTDIR ]; then
   echo "
              Creating KMSBII home directory
              (\`$ROOTDIR')
   "
   sleep 2
   mkdir -p $ROOTDIR
fi

if [ -f $INSTPATH/kside.png ]; then
 if [ -d $BACKUPDIR ]; then
    echo "
              It seems like you have previously installed KMSBII
              and have a backup directory already. 

              Backup directory
              (\`$BACKUPDIR')
              exists.

              Copying files into it.
    "
    cp $INSTPATH/kside* $BACKUPDIR
    rm $INSTPATH/kside*
    sleep 5
 else
    echo "
              It seems like you have previously installed KMSBII
              but backup directory doesn't exist.

              Creating backup directory now
              (\`$BACKUPDIR')
    "
    mkdir -p $BACKUPDIR
    sleep 5

    echo "    
              Done,
              copying files into it.
    "
    cp $INSTPATH/kside* $BACKUPDIR
    rm $INSTPATH/kside*
    sleep 5
 fi
fi

echo "
      :: 3 :: ==---------------------------------------------------------------- /

              Installing KDE Menu Sidebar Image Improvement for
              $VERSION
"
sleep 3
echo "
              Copying files to installation directory
              (\`$INSTPATH')"

cp $INSTDIR/kside* $INSTPATH
sleep 6
echo "
              Restarting kicker for changes to take effect."

killall -TERM kicker
sleep 1 
kicker
sleep 4
touch $UNINFOFILE
echo "user" > $UNINFOFILE
echo "        
              Done.
"
sleep 3
echo "
      :: ALL DONE :: ==---------------------------------------------------------- /

         Installation of KMSBII for $VERSION is now complete.
         LMB click on your KMenu button to check if everything is OK.


         Type:

         $ ./install.sh info                      $ ./install.sh help
                                       or
         to see more information                  to see a brief message
         about the project.                       on usage of this script.


         Thank you for giving this KDE improvement a try.
"
}

# --------------- System Wide -------------------- #

system() {
echo "
      KMSBII System-Wide Installation Mode  ------------------------------------ /

"

sleep 1

if [[ $SYSVERSION == "Slackware 10.0.0" ]]; then
 INSTDIR="./10.0.0"
 VERSION="Slackware GNU\Linux 10.0.0"
elif [[ $SYSVERSION == "Slackware 10.1.0" ]]; then
 INSTDIR="./10.1.0"
 VERSION="Slackware GNU\Linux 10.1.0"
elif [[ $SYSVERSION == "Slackware 10.2.0" ]]; then
 INSTDIR="./10.2.0"
 VERSION="Slackware GNU\Linux 10.2.0"
elif [[ $SYSVERSION == "Slackware 11.0.0" ]]; then
 INSTDIR="./11.0.0"
 VERSION="Slackware GNU\Linux 11.0.0"
fi

echo "
      :: 1 :: ==---------------------------------------------------------------- /

              Identifying $DISTRO version

"
sleep 3
echo "        
              Your version is:
              $VERSION
"
sleep 3
echo "
      :: 2 :: ==---------------------------------------------------------------- /

              Preparing target directory

"

sleep 5

if [ ! -d $SYSINSTPATH ]; then
   echo "
              Creating target directory
              (\`$SYSINSTPATH')
   "
   mkdir -p $SYSINSTPATH
   sleep 5
else
   echo "
              Target directroy
              (\`$SYSINSTPATH')
              exists.

              Fine.
              Lets move on.
   "
   sleep 5
fi

if [ ! -d $ROOTDIR ]; then
   echo "
              Creating KMSBII home directory
              (\`$ROOTDIR')
   "
   sleep 2
   mkdir -p $ROOTDIR
fi

if [ -f $SYSINSTPATH/kside.png ]; then
 if [ -d $BACKUPDIR ]; then
    echo "
              As you've chosen system-wide installation mode original KDE Menu
              Sidebar Image files ought to be backened up.

              It seems like you have previously installed KMSBII
              and have a backup directory already.

              Backup directory
              (\`$BACKUPDIR')
              exists.

              Copying files into it.
    "
    cp $SYSINSTPATH/kside* $BACKUPDIR
    rm $SYSINSTPATH/kside*
    sleep 5
 else
    echo "
              As you've chosen system-wide installation mode original KDE Menu
              Sidebar Image files ought to be backened up, but backup directory
              doesn't exist.

              Creating backup directory now
              (\`$BACKUPDIR')
    "
    mkdir -p $BACKUPDIR
    sleep 5
    echo "
              Done,
              copying files into it.
    "
    cp $SYSINSTPATH/kside* $BACKUPDIR
    rm $SYSINSTPATH/kside*
    sleep 5
 fi
fi

echo "
      :: 3 :: ==---------------------------------------------------------------- /

              Installing KDE Menu Sidebar Image Improvement for
              $VERSION
"
sleep 3
echo "
              Copying files to installation directory
              (\`$SYSINSTPATH')"

cp $INSTDIR/kside* $SYSINSTPATH
sleep 6
echo "
              Restarting kicker for changes to take effect."

killall -TERM kicker
sleep 1 
kicker
sleep 4
touch $UNINFOFILE
echo "system" > $UNINFOFILE
echo "        
              Done.
"
sleep 3
echo "
      :: ALL DONE :: ==---------------------------------------------------------- /

         Installation of KMSBII for $VERSION is now complete.
         LMB click on your KMenu button to check if everything is OK.


         Type:

         $ ./install.sh info                      $ ./install.sh help
                                       or
         to see more information                  to see a brief message
         about the project.                       on usage of this script.


         Thank you for giving this KDE improvement a try.
"
}

# --------------- Restore -------------------- #

restore() {
echo "
        :: RESTORE MODE :: ==------------------------------------------------- /
"
sleep 1
INSTTYPE=`cat $UNINFOFILE`

if [ -d $BACKUPDIR ]; then
 if [[ $INSTTYPE == "user" ]]; then
    echo "
           You chose single-user installation type previously.
           Running 'restore' mode accordingly
    "
    sleep 4
    mkdir -p $TMPDIR
    mv $INSTPATH/kside*.png $TMPDIR
    mv $BACKUPDIR/kside*.png $INSTPATH
    mv $TMPDIR/kside*.png $BACKUPDIR
    rm -r $TMPDIR
    echo "
           All done.
    "
    sleep 1
    echo "
           Restarting kicker for changes to take effect
    "
    killall -TERM kicker
    sleep 1
    kicker
    sleep 3
    echo "
           KMSBI files have been restored from the backup directory

           (\`$BACKUPDIR')

           and made your default KMSBI.

           Previous KMSBI set of files has been moved to backup
           directory. Run the ./install.sh in 'restore' mode
           again in order to change the KMSBI to backed up version.

    "
 elif [[ $INSTTYPE == "system" ]]; then
    echo "
           You chose system-wide installation type previously.
           Running 'restore' mode accordingly
    "
    sleep 4
    mkdir -p $TMPDIR
    mv $SYSINSTPATH/kside*.png $TMPDIR
    mv $BACKUPDIR/kside*.png $SYSINSTPATH
    mv $TMPDIR/kside*.png $BACKUPDIR
    rm -r $TMPDIR
    echo "
           All done.
    "
    sleep 1
    echo "
           Restarting kicker for changes to take effect
    "
    killall -TERM kicker
    sleep 1
    kicker
    sleep 3
    echo "
           KMSBI files have been restored from the backup directory

           (\`$BACKUPDIR')

           and made your default KMSBI.

           Previous KMSBI set of files has been moved to backup
           directory. Run the ./install.sh in 'restore' mode
           again in order to change the KMSBI to backed up version.

    "
 fi
   else
   echo "
         Cannot restore KMSBI backup files because
         there's no backup directory in the specified path:

         (\`$BACKUPDIR')


         Probably you haven't installed KMSBII yet or your
         installation got broken or there's simply nothing
         to restore.

         Sorry, cannot perform 'restore' action.
         Quitting now.
   "
fi
}

# --------------- Uninstallation -------------------- #

uninstall() {
echo "
        :: UNINSTALLATION :: ==------------------------------------------------- /
"
sleep 1
INSTTYPE=`cat $UNINFOFILE`

if [[ $INSTTYPE == "user" ]]; then
 if [ -d $BACKUPDIR ]; then
    cp $BACKUPDIR/* $INSTPATH
    rm -r $ROOTDIR
    killall -TERM kicker
    kicker
    sleep 1
    echo "
           Uninstallation is complete.


           Your KDE Menu sidebar images have been restored from the
           backup directory

           (\`$BACKUPDIR').
    "
     else
       rm -r $INSTPATH
       rm -r $ROOTDIR
       killall -TERM kicker
       kicker
       sleep 1
       echo "
           Uninstallation is complete.

           There was no backup directory, so original KDE Menu
           sidebar images have been restored.
       "
 fi
elif [[ $INSTTYPE == "system" ]]; then
 if [ -d $BACKUPDIR ]; then
  cp $BACKUPDIR/kside* $SYSINSTPATH
  rm -r $ROOTDIR
  killall -TERM kicker
  kicker
  sleep 1

  echo "
           Uninstallation is complete.


           Original KDE Menu sidebar images have been restored.
           from the backup directory

           (\`$BACKUPDIR').
  "
 else
  echo "
           /!\ Uninstallation is complete
               but an error occured, read further for details.


           Backup directory

           (\`$BACKUPDIR')

           cannot be found.


           That's weird because it is expected to be right
           there and system-wide installation mode takes
           care of baking up original KMSBI files and puts
           them into that directory. Perhaps, you or the
           administrator of the system removed the directory.

           It means that original KMSBI are probably lost
           forever.

           Original KDE Menu Sidebar Image files cannot be restored.
           
           (Sorry, you'll have to live with current KMSB images
           or ask your friends to make you a copy of the
           appropriate files)


           Removing KMSBII datadir and project related files..."
           rm -r $ROOTDIR
echo "           Done.

  "
 fi
fi
}

# --------------- Help -------------------- #

help() {
echo "
      :: HELP :: ==-------------------------------------------------------------- /


         Now you can have control over your installation with the help of this
         script, below you can see what it can do. Some abbreviations are used
         throughout the help messages so you should take a look at their 
         meaning.


         ABBREVIATIONS             MEANING

           KMSBII                    KDE Menu Sidebar Image Improvement package.
                                     Set of 'kside*.png' files used to replace
                                     default ones shipped with KDE.

           KMSBI                     KDE Menu Sidebar Image files.
                                     'kside*.png' files are referred to as KMSBI
                                     for convenient reading of the help messages.

           KDE                       K Desktop Environment (www.kde.org)
                                     A powerful Desktop Environment for UNIX.


         USAGE

           ./install.sh user|system|restore|uninstall|help|info


         COMMAND                   DESCRIPTION

           ./install.sh user         -runs single-user installation type. In
                                      this mode KMSBII will be installed for
                                      only one user, i.e. a user you're
                                      currently logged as into the system.

           ./install.sh system       -runs system-wide installation type;
                                      affects all users of a system. You have to
                                      be logged in as root user in order to run
                                      script in this mode.

           ./install.sh restore      -restores previous installation of KMSBII.
                                      In this mode the script attempts to take 
                                      image files from the backup directory and
                                      make them default KMSBII. If you did a
                                      single-user installation then 'restore'
                                      will work in the same mode, if it was
                                      system-wide installation type it'll work
                                      accordingly.

                                      The idea is that you can safely swap
                                      original KMSBI shipped with your default
                                      KDE distribution and KMSBII.

           ./install.sh uninstall    -attempts to remove KMSBII completely from
                                      your system according to the type of the
                                      installation you chose to install it. 
                                      Basically, it reverts to default KDE
                                      settings and removes KMSBII completely
                                      from your system.

           ./install.sh help         -lets you see this brief help message.

           ./install.sh info         -displays detailed information on the
                                      project, such as description, contacts,
                                      project URL, etc.
"
}

# --------------- Info -------------------- #

info() {
echo "
      :: INFO :: ==-------------------------------------------------------------- /

         KMSBII $VERSION for $DISTRO


         URL

         http://www.kde-look.org/content/show.php?content=37628


         Description

         KDE Menu Sidebar Image Improvement is a simple improvement for your KDE
         Menu that replaces default KDE Menu Sidebar image with one designed 
         specifically for your $DISTRO.

         Having say a Slackware or Debian or FreeBSD or any other 
         OS/distribution logo instead of default KDE gear may be a much better
         choice for those of you who are just in love with your favorite *nix.

         Personalized it looks sexy, it looks witty, it stresses the facts.


         Maintainer

         Ivan Lezhnev, Jr < lezhnev@gmail.com >


         If you have any questions/suggestions feel free to write me an e-mail
         or you can contact me directly on IRC:

         ilj, #kde@freenode.net
"
}


# // -----------------------------------------------
#
#                    MAIN
#
# ----------------------------------------------- //

case "$1" in
'user')
 user
;;
'system')
 system
;;
'restore')
 restore 
 ;;
'uninstall')
 uninstall
 ;;
'help')
 help
;;
'info')
 info 
 ;;
 *)
 echo "usage $0 user|system|restore|uninstall|help|info"
esac
